
//#property copyright "Copyright  2007, MetaQuotes Software Corp."
//#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 White
#property indicator_width1 1
#property indicator_style1 2

extern bool show.line.data=true;

extern int Lookback = 55;//10;
double g_ibuf_80[],DecNos;
int gi_unused_84 = 0;

int init() {
   SetIndexBuffer(0, g_ibuf_80);
   string ls_0 = "TESTING";
   IndicatorShortName(ls_0);
   return (0);
}

int deinit() {
   return (0);
}

int start() {

   if (StringFind (Symbol(), "JPY", 0) != -1){ DecNos = 2;}
   else { DecNos = 4; } 

   int li_4;
   int li_8;
   for (int li_0 = Bars - Lookback; li_0 >= 0; li_0--) {
      if (Close[li_0] > iMA(NULL, 0, Lookback, 0, MODE_LWMA, PRICE_HIGH, li_0 + 1)) li_8 = 1;
      else {
         if (Close[li_0] < iMA(NULL, 0, Lookback, 0, MODE_LWMA, PRICE_LOW, li_0 + 1)) li_8 = -1;
         else li_8 = 0;
      }
      if (li_8 != 0) li_4 = li_8;
      if (li_4 == -1) g_ibuf_80[li_0] = iMA(NULL, 0, Lookback, 0, MODE_LWMA, PRICE_HIGH, li_0);
      else g_ibuf_80[li_0] = iMA(NULL, 0, Lookback, 0, MODE_LWMA, PRICE_LOW, li_0);
   }
   //Comment("HiLo= ", g_ibuf_80[li_0 + 1]);
   double tvx = g_ibuf_80[li_0 + 1];
    if (show.line.data) {  
      ////////////////////////////
      ObjectDelete("ftx");
      ObjectCreate("ftx", OBJ_LABEL, 1, 0, 0);
      ObjectSetText("ftx", "HiLo: "+DoubleToStr(tvx,DecNos), 16, "Arial", DodgerBlue);
      ObjectSet("ftx", OBJPROP_CORNER, 0);
      ObjectSet("ftx", OBJPROP_BACK, false);
      ObjectSet("ftx", OBJPROP_XDISTANCE, 485);
      ObjectSet("ftx", OBJPROP_YDISTANCE, 5);
      /////////////////////////////////////////
}
   
   return (0);
}