
//+-----------------------------------------------------------------------+
//|                                       XARD CROSSOVER  \/             |
//|                            Knowledge of the ancients ( )            |
//|_________________________________________________o0o___(_)___o0o_______|
//|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|
//|                                                            by XARD777 |
//|-----------------------------------------------------------------------|
//| Programming language: MQL4                                            |
//| Development platform: MetaTrader 4                                    |
//|          End product: Indicator for MetaTrader 4 designed             |
//|                       for Build 226 (current version)                 |
//+-----------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Yellow
#property indicator_color2 Yellow
#property indicator_color3 Lime
#property indicator_color4 Lime
#property indicator_color5 Blue
#property indicator_color6 Blue
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 1

double CrossUp1[];
double CrossDown1[];
double CrossUp2[];
double CrossDown2[];
double CrossUp3[];
double CrossDown3[];
extern int     FasterEMA1 = 3;
//extern int     SlowerEMA1 = 13;
double SlowerEMA1;
extern int     FasterEMA2 = 3;
//extern int     SlowerEMA2 = 52;
double SlowerEMA2;
extern int     FasterEMA3 = 3;
//extern int     SlowerEMA3 = 104;
double SlowerEMA3;

extern bool    SoundON          = true;
double alertTag;
double control=2147483647;
 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
   {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW, EMPTY);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, CrossUp1);
   SetIndexStyle(1, DRAW_ARROW, EMPTY);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, CrossDown1);
   SetIndexStyle(2, DRAW_ARROW, EMPTY);
   SetIndexArrow(2, 233);
   SetIndexBuffer(2, CrossUp2);
   SetIndexStyle(3, DRAW_ARROW, EMPTY);
   SetIndexArrow(3, 234);
   SetIndexBuffer(3, CrossDown2);
   SetIndexStyle(4, DRAW_ARROW, EMPTY);
   SetIndexArrow(4, 233);
   SetIndexBuffer(4, CrossUp3);
   SetIndexStyle(5, DRAW_ARROW, EMPTY);
   SetIndexArrow(5, 234);
   SetIndexBuffer(5, CrossDown3);

   switch ( Period() )
         {
          case 5: SlowerEMA1  =  78;break;
          case 15:SlowerEMA1  =  26;break;
          default:SlowerEMA1  =  13;break;
         }
   
   switch ( Period() )
         {
          case 5: SlowerEMA2  =  312;break;
          case 15:SlowerEMA2  =  104;break;
          default:SlowerEMA2  =  52;break;
         }
         
   switch ( Period() )
         {
          case 5: SlowerEMA3  =  624;break;
          case 15:SlowerEMA3  =  208;break;
          default:SlowerEMA3  =  104;break;
         }         

//----
   return(0);
   }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
   {
   
   return(0);
   } 
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
   {
   int limit, i, counter;
   double fasterEMA1now, slowerEMA1now, fasterEMA1previous, slowerEMA1previous, fasterEMA1after, slowerEMA1after;
   double fasterEMA2now, slowerEMA2now, fasterEMA2previous, slowerEMA2previous, fasterEMA2after, slowerEMA2after;
   double fasterEMA3now, slowerEMA3now, fasterEMA3previous, slowerEMA3previous, fasterEMA3after, slowerEMA3after;
   
   double Range, AvgRange;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;
   
   for(i = 0; i <= limit; i++) 
      {
      counter=i;
      Range=0;
      AvgRange=0;
      for (counter=i ;counter<=i+9;counter++)
         {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
         }
      Range=AvgRange/10;
       
      fasterEMA1now = iMA(NULL, 0, FasterEMA1, 0, MODE_EMA, PRICE_CLOSE, i);
      fasterEMA1previous = iMA(NULL, 0, FasterEMA1, 0, MODE_EMA, PRICE_CLOSE, i+1);
      fasterEMA1after = iMA(NULL, 0, FasterEMA1, 0, MODE_EMA, PRICE_CLOSE, i-1);

      slowerEMA1now = iMA(NULL, 0, SlowerEMA1, 0, MODE_EMA, PRICE_CLOSE, i);
      slowerEMA1previous = iMA(NULL, 0, SlowerEMA1, 0, MODE_EMA, PRICE_CLOSE, i+1);
      slowerEMA1after = iMA(NULL, 0, SlowerEMA1, 0, MODE_EMA, PRICE_CLOSE, i-1);
      
      if ((fasterEMA1now > slowerEMA1now) && (fasterEMA1previous < slowerEMA1previous) && (fasterEMA1after > slowerEMA1after))
         {
         CrossUp1[i] = Low[i] - Range*0.5;
         }
      else if ((fasterEMA1now < slowerEMA1now) && (fasterEMA1previous > slowerEMA1previous) && (fasterEMA1after < slowerEMA1after)) 
         {
         CrossDown1[i] = High[i] + Range*0.5;
         }
      if (SoundON==true && i==1 && CrossUp1[i] > CrossDown1[i] && alertTag!=Time[0])
         {
         Alert("EMA Cross Trend going Down on ",Symbol()," ",Period(),",   ",FasterEMA1,"/",SlowerEMA1," Periods");
         alertTag = Time[0];
         }
      if (SoundON==true && i==1 && CrossUp1[i] < CrossDown1[i] && alertTag!=Time[0])
         {
         Alert("EMA Cross Trend going Up on ",Symbol()," ",Period(),",   ",FasterEMA1,"/",SlowerEMA1," Periods");
         alertTag = Time[0];
         }
         
//-----second EMA crossover------------------      
       
      fasterEMA2now = iMA(NULL, 0, FasterEMA2, 0, MODE_EMA, PRICE_CLOSE, i);
      fasterEMA2previous = iMA(NULL, 0, FasterEMA2, 0, MODE_EMA, PRICE_CLOSE, i+1);
      fasterEMA2after = iMA(NULL, 0, FasterEMA2, 0, MODE_EMA, PRICE_CLOSE, i-1);

      slowerEMA2now = iMA(NULL, 0, SlowerEMA2, 0, MODE_EMA, PRICE_CLOSE, i);
      slowerEMA2previous = iMA(NULL, 0, SlowerEMA2, 0, MODE_EMA, PRICE_CLOSE, i+1);
      slowerEMA2after = iMA(NULL, 0, SlowerEMA2, 0, MODE_EMA, PRICE_CLOSE, i-1);
      
      if ((fasterEMA2now > slowerEMA2now) && (fasterEMA2previous < slowerEMA2previous) && (fasterEMA2after > slowerEMA2after))
         {
         CrossUp2[i] = Low[i] - Range*0.5;
         }
      else if ((fasterEMA2now < slowerEMA2now) && (fasterEMA2previous > slowerEMA2previous) && (fasterEMA2after < slowerEMA2after)) 
         {
         CrossDown2[i] = High[i] + Range*0.5;    
         }
      if (SoundON==true && i==1 && CrossUp2[i] > CrossDown2[i] && alertTag!=Time[0])
         {
         Alert("EMA Cross Trend going Down on ",Symbol()," ",Period(),",   ",FasterEMA2,"/",SlowerEMA2," Periods");
         alertTag = Time[0];
         }
      if (SoundON==true && i==1 && CrossUp2[i] < CrossDown2[i] && alertTag!=Time[0])
         {
         Alert("EMA Cross Trend going Up on ",Symbol()," ",Period(),",   ",FasterEMA2,"/",SlowerEMA2," Periods");
         alertTag = Time[0];
         }
    

//-----third EMA crossover------------------      
       
      fasterEMA3now = iMA(NULL, 0, FasterEMA3, 0, MODE_EMA, PRICE_CLOSE, i);
      fasterEMA3previous = iMA(NULL, 0, FasterEMA3, 0, MODE_EMA, PRICE_CLOSE, i+1);
      fasterEMA3after = iMA(NULL, 0, FasterEMA3, 0, MODE_EMA, PRICE_CLOSE, i-1);

      slowerEMA3now = iMA(NULL, 0, SlowerEMA3, 0, MODE_EMA, PRICE_CLOSE, i);
      slowerEMA3previous = iMA(NULL, 0, SlowerEMA3, 0, MODE_EMA, PRICE_CLOSE, i+1);
      slowerEMA3after = iMA(NULL, 0, SlowerEMA3, 0, MODE_EMA, PRICE_CLOSE, i-1);
      
      if ((fasterEMA3now > slowerEMA3now) && (fasterEMA3previous < slowerEMA3previous) && (fasterEMA3after > slowerEMA3after))
         {
         CrossUp3[i] = Low[i] - Range*0.5;
         }
      else if ((fasterEMA3now < slowerEMA3now) && (fasterEMA3previous > slowerEMA3previous) && (fasterEMA3after < slowerEMA3after)) 
         {
         CrossDown3[i] = High[i] + Range*0.5;    
         }
      if (SoundON==true && i==1 && CrossUp3[i] > CrossDown3[i] && alertTag!=Time[0])
         {
         Alert("EMA Cross Trend going Down on ",Symbol()," ",Period(),",   ",FasterEMA3,"/",SlowerEMA3," Periods");
         alertTag = Time[0];
         }
      if (SoundON==true && i==1 && CrossUp3[i] < CrossDown3[i] && alertTag!=Time[0])
         {
         Alert("EMA Cross Trend going Up on ",Symbol()," ",Period(),",   ",FasterEMA3,"/",SlowerEMA3," Periods");
         alertTag = Time[0];
         }    
         
      
      }
   return(0);
}  


