////////////////////////////////////////////////////////////////
//                   adapted by MaXno.                        //
////////////////////////////////////////////////////////////////

#property copyright ""
#property link      "http://www.bithedz.com/"

#property indicator_separate_window
#property indicator_minimum 0.0
#property indicator_maximum 100.0
#property indicator_buffers 1
#property indicator_color1 Black

string WindowName = " ";
extern int font_size = 9;
extern bool DisplayLegend = TRUE;
extern bool DisplayCommentary = TRUE;
extern bool DisplayScan = TRUE;
extern bool DisplayTargets = TRUE;
extern color TitlesColor = Blue;
extern color TextColor = LightSlateGray;
extern color BullishColor = Lime;
extern color BearishColor = Red;
extern color ProfitTargetColor = Blue;
extern color LossTargetColor = FireBrick;
//extern string sLBForPat = "  ";
extern int LookBackForPattern = 50;
extern string sAlert_H4 = "   ";
extern bool Alert_H4 = true;

int g_color_132 = Red;
int WindowNum = 0;
int gi_140 = 1;
int pattern_type = 0;
int gi_148 = 0;
int gi_152 = 0;
int gi_156 = 0;
double g_price_160;
double SL;
double TP;
string g_name_184;
string TP_str = "0.0";
string SL_str = "0.0";

int NewPat = 0;
int OldPat = 50;
datetime TimeNewPat = 0;
datetime TimeOldPat = 0;

datetime TimeNewBarH1 = 0;
datetime TimeOldBarH1 = 0;

int init() {
   IndicatorShortName(WindowName);
   return (0);
}

int deinit() {
   CleanUp();
   return (0);
}

int start() {
TimeNewBarH1 = iTime(Symbol(),PERIOD_H1,0);
   //TimeOldBarH1 = GlobalVariableGet(Symbol()+"_OP_TimeOldBarH1");
   if ((TimeNewBarH1-TimeOldBarH1)>=3600)
      {
      TimeOldBarH1 = TimeNewBarH1;
      //GlobalVariableSet(Symbol()+"_OP_TimeOldBarH1",TimeOldBarH1);

   double koeff_2_kanal;
   double ld_8;
   double spred;
   int koeff_kanal;
   int li_28;
   double ld_32;
   int normalise_JPY = CheckPrecision();
   int li_44 = IndicatorCounted();
   //----     
   if (li_44 < 0) return (-1);
   if (li_44 > 0) li_44--;
   int limitBar = Bars - li_44;

   for (int shift_a = limitBar; shift_a > 0; shift_a--) {
      if (WindowFind(WindowName) == -1) WindowNum = WindowsTotal() - 1;
      else WindowNum = WindowFind(WindowName);
      koeff_2_kanal = 0.0;
      ld_8 = 0.0;
      for (int shift_b = shift_a; shift_b <= shift_a + 14; shift_b++) ld_8 += MathAbs(High[shift_b] - Low[shift_b]);
      koeff_2_kanal = ld_8 / 10.0;
      pattern_type = FindPattern(Symbol(), shift_a, 0);
      if (pattern_type != 0) {
         spred = Ask - Bid;
         koeff_kanal = 2;
         li_28 = 10;
         ld_32 = 2.0;
         switch (Period()) {
         case PERIOD_M1:
            koeff_kanal = 5;
            li_28 = 20;
            ld_32 = 5.0 * Point;
            break;
         case PERIOD_M5:
            koeff_kanal = 3;
            li_28 = 20;
            ld_32 = 5.0 * Point;
            break;
         case PERIOD_M15:
            koeff_kanal = 2;
            li_28 = 20;
            ld_32 = 10.0 * Point;
            break;
         case PERIOD_M30:
            koeff_kanal = 1.85;
            li_28 = 20;
            ld_32 = 10.0 * Point;
            break;
         case PERIOD_H1:
            koeff_kanal = 1.7;
            li_28 = 20;
            ld_32 = 15.0 * Point;
            break;
         case PERIOD_H4:
            koeff_kanal = 1.55;
            li_28 = 20;
            ld_32 = 15.0 * Point;
            break;
         case PERIOD_D1:
            koeff_kanal = 1.4;
            li_28 = 20;
            ld_32 = 40.0 * Point;
            break;
         case PERIOD_W1:
            koeff_kanal = 1.25;
            li_28 = 20;
            ld_32 = 50.0 * Point;
            break;
         case PERIOD_MN1:
            koeff_kanal = 1.1;
            li_28 = 20;
            ld_32 = 80.0 * Point;
            break;
         default:
            Alert("Invalid Periodicity");
            return (-1);
         }
         switch (pattern_type) {
         case 1:
            gi_156 = 119;
            g_color_132 = BearishColor;
            TP = Open[shift_a] + koeff_2_kanal * koeff_kanal;
            SL = Low[shift_a] - koeff_2_kanal * koeff_kanal - spred;
            g_price_160 = High[shift_a] + koeff_2_kanal;
            break;
         case 2:
            gi_156 = 119;
            g_color_132 = BullishColor;
            TP = Close[shift_a] - koeff_2_kanal * koeff_kanal;
            SL = High[shift_a] + koeff_2_kanal * koeff_kanal + spred;
            g_price_160 = Low[shift_a] - koeff_2_kanal;
            break;
         case 3:
            gi_156 = 88;
            g_color_132 = BearishColor;
            TP = Open[shift_a] + koeff_2_kanal * koeff_kanal;
            SL = Low[shift_a] - koeff_2_kanal * koeff_kanal - spred;
            g_price_160 = High[shift_a] + koeff_2_kanal;
            break;
         case 4:
            gi_156 = 88;
            g_color_132 = BullishColor;
            TP = Close[shift_a] - koeff_2_kanal * koeff_kanal;
            SL = High[shift_a] + koeff_2_kanal * koeff_kanal + spred;
            g_price_160 = Low[shift_a] - koeff_2_kanal;
            break;
         case 5:
            gi_156 = 172;
            g_color_132 = BearishColor;
            TP = Open[shift_a] + koeff_2_kanal * koeff_kanal;
            SL = Low[shift_a] - koeff_2_kanal * koeff_kanal - spred;
            g_price_160 = High[shift_a] + koeff_2_kanal;
            break;
         case 6:
            gi_156 = 172;
            g_color_132 = BullishColor;
            TP = Close[shift_a] - koeff_2_kanal * koeff_kanal;
            SL = High[shift_a] + koeff_2_kanal * koeff_kanal + spred;
            g_price_160 = Low[shift_a] - koeff_2_kanal;
            break;
         case 7:
            gi_156 = 83;
            g_color_132 = BearishColor;
            TP = Open[shift_a] + koeff_2_kanal * koeff_kanal;
            SL = Low[shift_a] - koeff_2_kanal * koeff_kanal - spred;
            g_price_160 = High[shift_a] + koeff_2_kanal;
            break;
         case 8:
            gi_156 = 83;
            g_color_132 = BullishColor;
            TP = Close[shift_a] - koeff_2_kanal * koeff_kanal;
            SL = High[shift_a] + koeff_2_kanal * koeff_kanal + spred;
            g_price_160 = Low[shift_a] - koeff_2_kanal;
            break;
         case 9:
            gi_156 = 159;
            g_color_132 = BearishColor;
            TP = Open[shift_a] + koeff_2_kanal * koeff_kanal;
            SL = Low[shift_a] - koeff_2_kanal * koeff_kanal - spred;
            g_price_160 = High[shift_a] + koeff_2_kanal;
            break;
         case 10:
            gi_156 = 159;
            g_color_132 = BullishColor;
            TP = Close[shift_a] - koeff_2_kanal * koeff_kanal;
            SL = High[shift_a] + koeff_2_kanal * koeff_kanal + spred;
            g_price_160 = Low[shift_a] - koeff_2_kanal;
            break;
         default:
            Alert("error in switch pattern");
            return (-1);
         }
         g_name_184 = "IBFXCPRPATTERN" + gi_140;
         ObjectCreate(g_name_184, OBJ_ARROW, 0, Time[shift_a], g_price_160);
         ObjectSet(g_name_184, OBJPROP_ARROWCODE, gi_156);
         ObjectSet(g_name_184, OBJPROP_COLOR, g_color_132);
         TP_str = DoubleToStr(TP, normalise_JPY);
         SL_str = DoubleToStr(SL, normalise_JPY);
         gi_140++;
         gi_148 = pattern_type;
         gi_152 = shift_a;
         DrawLegend(DisplayLegend, DisplayCommentary, DisplayScan, font_size, shift_a, WindowNum, gi_148, gi_152, TP_str, SL_str, BullishColor, BearishColor, TextColor);
         if (DisplayTargets) DrawTarget(li_28, ld_32, SL, TP, koeff_kanal, koeff_2_kanal, g_color_132);
      }
   }
   }
   return (0);
}

void DrawTarget(int ai_0, double ad_4, double a_price_12, double a_price_20, int ai_unused_28, double ad_unused_32, int ai_40) {
   ObjectDelete("PROFITTARGET");
   ObjectDelete("STOPTARGET");
   if (ai_40 == BullishColor) {
      ObjectCreate("PROFITTARGET", OBJ_RECTANGLE, 0, Time[ai_0], a_price_12, Time[0], a_price_12 + ad_4);
      ObjectSet("PROFITTARGET", OBJPROP_COLOR, ProfitTargetColor);
      ObjectCreate("STOPTARGET", OBJ_RECTANGLE, 0, Time[ai_0], a_price_20, Time[0], a_price_20 - ad_4);
      ObjectSet("STOPTARGET", OBJPROP_COLOR, LossTargetColor);
      return;
   }
   if (ai_40 == BearishColor) {
      ObjectCreate("PROFITTARGET", OBJ_RECTANGLE, 0, Time[ai_0], a_price_12, Time[0], a_price_12 - ad_4);
      ObjectSet("PROFITTARGET", OBJPROP_COLOR, ProfitTargetColor);
      ObjectCreate("STOPTARGET", OBJ_RECTANGLE, 0, Time[ai_0], a_price_20, Time[0], a_price_20 + ad_4);
      ObjectSet("STOPTARGET", OBJPROP_COLOR, LossTargetColor);
   }
}

int FindPattern(string a_symbol_0, int shift, int a_timeframe_12) {
   double close_1 = iClose(a_symbol_0, a_timeframe_12, shift);
   double close_2 = iClose(a_symbol_0, a_timeframe_12, shift + 1);
   double close_3 = iClose(a_symbol_0, a_timeframe_12, shift + 2);
   double open_1 = iOpen(a_symbol_0, a_timeframe_12, shift);
   double open_2 = iOpen(a_symbol_0, a_timeframe_12, shift + 1);
   double open_3 = iOpen(a_symbol_0, a_timeframe_12, shift + 2);
   double low_1 = iLow(a_symbol_0, a_timeframe_12, shift);
   double low_2 = iLow(a_symbol_0, a_timeframe_12, shift + 1);
   double low_3 = iLow(a_symbol_0, a_timeframe_12, shift + 2);
   double high_1 = iHigh(a_symbol_0, a_timeframe_12, shift);
   double high_2 = iHigh(a_symbol_0, a_timeframe_12, shift + 1);
   double high_3 = iHigh(a_symbol_0, a_timeframe_12, shift + 2);

//==========================  ===========================

//==========================   ===========================
if (close_3 > open_3 
  // && (close_3 - open_3) / (high_3 + 0.001 - low_3) > 0.6 
   && close_3 < open_2 
   && close_3 < close_2 
   && ( close_2 > open_2 || open_2 > close_2 || open_2 == close_2 )
   //&& MathAbs(high_2 - low_2) > 3.0 * MathAbs(close_2 - open_2) 
   && MathAbs(close_2 - open_2) < MathAbs(close_3 - open_3)
   && MathAbs(close_2 - open_2) <= MathAbs(close_1 - open_1)
   && open_1 > close_1 
   && high_1 <= high_2
   //&& open_1 <= open_2 || open_1 <= close_2 
   && close_1 > open_3 
   ) return (1);
/*
if (close_3 > open_3 
   && (close_3 - open_3) / (high_3 + 0.001 - low_3) > 0.6 
   && close_3 < open_2 
   && close_2 > open_2 
   && high_2 - low_2 > 3.0 * (close_2 - open_2) 
   && open_1 > close_1 
   && open_1 < open_2
   ) return (1);
   */
//==========================   ===========================
if (open_3 > close_3 
   //&& (open_3 - close_3) / (high_3 + 0.001 - low_3) > 0.6 
   && close_3 > open_2 
   && close_3 > close_2 
   && ( close_2 > open_2 || open_2 > close_2 || open_2 == close_2 )
//   && high_2 - low_2 > 3.0 * (close_2 - open_2) 
   && MathAbs(close_2 - open_2) < MathAbs(close_3 - open_3)
   && MathAbs(close_2 - open_2) <= MathAbs(close_1 - open_1)
   && close_1 > open_1 
   && low_1 >= low_2
//   && open_1 <= open_2 || open_1 <= close_2
   && close_1 < open_3 
   ) return (2);
/*
if (open_3 > close_3 
   && (open_3 - close_3) / (high_3 + 0.001 - low_3) > 0.6 
   && close_3 > open_2 
   && open_2 > close_2 
   && high_2 - low_2 > 3.0 * (close_2 - open_2) 
   && close_1 > open_1 
   && open_1 > open_2
   ) return (2);
   */

//==========================    ===========================
if (open_1 > close_1 
   && open_2 > close_2 
   && open_3 >= close_3 
   && close_1 < close_2 
   && close_2 < close_3 
   && open_1 >= close_2 
   && open_1 < open_2 
   //&& open_2 >= close_3 
   //&& open_2 < open_3 
   //&& (open_2 - close_2) >= (open_3 - close_3) / 2
   //&& (open_1 - close_1) >= (open_2 - close_2) / 2
   && (close_1 - low_1) / (high_1 - low_1 + 0.001) < 0.2 
   && (close_2 - low_2) / (high_2 - low_2 + 0.001) < 0.2 
   && (close_3 - low_3) / (high_3 - low_3 + 0.001) < 0.2
   ) return (9);

//==========================    ===========================
if (close_1 > open_1 
   && close_2 > open_2 
   && close_3 >= open_3 
   && close_1 > close_2 
   //&& close_2 > close_3 
   //&& open_1 < close_2 
   && open_1 > open_2 
   //&& open_2 < close_3 
   && open_2 > open_3 
   //&& (close_2 - open_2) >= (close_3 - open_3) / 2
   //&& (close_1 - open_1) >= (close_2 - open_2) / 2
   && (high_1 - close_1) / (high_1 - low_1 + 0.001) < 0.2 
   && (high_2 - close_2) / (high_2 - low_2 + 0.001) < 0.2 
   && (high_3 - close_3) / (high_3 - low_3 + 0.001) < 0.2
   ) return (10);

//==========================     ===========================
if (close_2 > open_2 
   && (close_2 + open_2) / 2.0 > close_1 
   && open_1 > close_1 
   && open_1 > close_2 
   && close_1 > open_2 
   && (open_1 - close_1) / (high_1 - low_1 + 0.0001) > 0.6
   ) return (7);

//==========================   ===========================
if (close_2 < open_2 
   && (open_2 + close_2) / 2.0 < close_1 
   && open_1 < close_1 
   && open_1 < close_2 
   && close_1 < open_2 
   && (close_1 - open_1) / (high_1 - low_1 + 0.0001) > 0.6
   ) return (8);


//===========================     =====================================
if (close_3 > open_3 
   && open_2 > close_2 
   && open_2 >= close_3 
   && open_3 >= close_2 
   && open_2 - close_2 > close_3 - open_3 
   //&& open_1 - close_1 > close_3 - open_3 
   && open_1 > close_1 
   && close_1 < close_2
   //&& high_1 >= open_3
   )    return (3);

//===========================     =====================================
if (open_3 > close_3 
   && close_2 > open_2 
   && close_2 >= open_3 
   && close_3 >= open_2 
   && close_2 - open_2 > open_3 - close_3 
   //&& close_1 - open_1 > open_3 - close_3 
   && close_1 > open_1 
   && close_1 > close_2
   //&& low_1 <= open_3
   ) return (4);

//===========================     =====================================
if (close_3 > open_3 && open_2 > close_2 && open_2 <= close_3 && open_3 <= close_2 && open_2 - close_2 < close_3 - open_3 &&
   open_1 > close_1 && close_1 < close_2 && open_1 < open_2) return (5);

/*
if ((close_3 > open_3) 
   && (open_2 >= close_2) 
   && (open_2 <= close_3) 
   && (open_3 < close_2) 
   //&& (close_3 >= high_2) 
   && (open_2 - close_2) < (close_3 - open_3)
   && (open_1 > close_1) 
   && (close_1 < close_2) 
   && (open_1 < open_2) 
   //&& (close_1 < low_3)
   && (close_1 < open_3) || (low_1 < open_3)
   //&& (low_1 < open_3)
   ) return (5);     
*/
//===========================     =====================================
if (open_3 > close_3 && close_2 > open_2 && close_2 <= open_3 && close_3 <= open_2 && close_2 - open_2 < open_3 - close_3 &&
   close_1 > open_1 && close_1 > close_2 && open_1 > open_2) return (6);
/*
if ((open_3 > close_3) 
   && (close_2 >= open_2) 
   && (open_2 >= close_3) 
   && (close_2 <= open_3) 
   //&& (close_3 <= low_2) 
   && (open_3 > close_2) 
   && (close_2 - open_2) < (open_3 - close_3)
   && (close_1 > open_1) 
   && (close_1 > close_2) 
   && (open_1 > open_2) 
   //&& (close_1 > high_3)
   && ((close_1 > open_3) || (high_1 > open_3))
   //&& (high_1 > open_3)
   ) return (6);
*/
return (0);
}

void DrawLegend(bool DisplLeg, bool DispComment, bool DispScan, int a_fontsize_12, int ai_unused_16, int ai_20, int ai_24, int ai_28, string as_32, string as_40, color a_color_48, color a_color_52, color a_color_56) {
   color l_color_60;
   color l_color_64;
   string l_text_68;
   string l_text_76;
   string l_text_84;
   string l_text_92;
   string l_text_100;
   string l_text_108;
   string ls_unused_116;
   string l_text_124;
   string l_text_132;
   int l_count_140;
   int pattern_type;
   string l_text_148;
   int li_156 = 10;
   int li_160 = 25;
   if (DisplayLegend) {
      ObjectMakeLabel("LegendColorUp", a_fontsize_12, 25, ai_20);
      ObjectSetText("LegendColorUp", " Color", a_fontsize_12, "Arial Bold", a_color_48);
      ObjectMakeLabel("LegendColorSU", 150, 27, ai_20);
      ObjectSetText("LegendColorSU", "n", a_fontsize_12, "Wingdings", a_color_48);
      ObjectMakeLabel("LegendColorDn", a_fontsize_12, 45, ai_20);
      ObjectSetText("LegendColorDn", " Color", a_fontsize_12, "Arial Bold", a_color_52);
      ObjectMakeLabel("LegendColorSN", 150, 47, ai_20);
      ObjectSetText("LegendColorSN", "n", a_fontsize_12, "Wingdings", a_color_52);
      ObjectMakeLabel("ENGULFING", a_fontsize_12, 65, ai_20);
      ObjectSetText("ENGULFING", "  / ", a_fontsize_12, "Arial Bold", a_color_56);
      ObjectMakeLabel("ENGULFINGS", 149, 67, ai_20);
      ObjectSetText("ENGULFINGS", "u", a_fontsize_12, "Wingdings", a_color_56);
      ObjectMakeLabel("SOLDIER", a_fontsize_12, 85, ai_20);
      ObjectSetText("SOLDIER", " / ", a_fontsize_12, "Arial Bold", a_color_56);
      ObjectMakeLabel("SOLDIERS", 150, 85, ai_20);
      ObjectSetText("SOLDIERS", "l", a_fontsize_12, "Wingdings", a_color_56);
      ObjectMakeLabel("INSIDE", a_fontsize_12, 105, ai_20);
      ObjectSetText("INSIDE", "  ", a_fontsize_12, "Arial Bold", a_color_56);
      ObjectMakeLabel("INSIDES", 150, 107, ai_20);
      ObjectSetText("INSIDES", "", a_fontsize_12, "Wingdings", a_color_56);
      ObjectMakeLabel("OUTSIDE", a_fontsize_12, 125, ai_20);
      ObjectSetText("OUTSIDE", "  ", a_fontsize_12, "Arial Bold", a_color_56);
      ObjectMakeLabel("OUTSIDES", 151, 127, ai_20);
      ObjectSetText("OUTSIDES", "X", a_fontsize_12, "Wingdings", a_color_56);
      ObjectMakeLabel("CLOUD", a_fontsize_12, 145, ai_20);
      ObjectSetText("CLOUD", "", a_fontsize_12, "Arial Bold", a_color_56);
      ObjectMakeLabel("CLOUDS", 151, 146, ai_20);
      ObjectSetText("CLOUDS", "S", a_fontsize_12, "Wingdings", a_color_56);
      li_156 += 160;
      li_160 = 2;
   }
   if (DispComment) {
      ObjectMakeLabel("CommentaryTitle", li_156, li_160, ai_20);
      ObjectSetText("CommentaryTitle", "", 10, "Arial Bold", TitlesColor);
      l_color_60 = Green;
      l_color_64 = a_color_56;
      l_text_68 = "";
      l_text_76 = "";
      l_text_84 = "";
      l_text_92 = "";
      l_text_100 = "";
      l_text_108 = "";
      ls_unused_116 = "";
      l_text_124 = "";
      l_text_132 = "";
      switch (ai_24) {
      case 1:
         l_text_124 = "  :";
         l_text_132 = (ai_28 + 1) + "  ";
         l_text_68 = " ";
         l_text_76 = "  ,   ";
         l_text_84 = "       .";
         l_text_92 = "  ";
         l_text_100 = "SL: " + as_32;
         l_text_108 = "TP: " + as_40;
         l_color_60 = a_color_52;
         break;
      case 2:
         l_text_124 = "  :";
         l_text_132 = (ai_28 + 1) + "  ";
         l_text_68 = " ";
         l_text_76 = "  ,   ";
         l_text_84 = "       .";
         l_text_92 = "  ";
         l_text_100 = "SL: " + as_32;
         l_text_108 = "TP: " + as_40;
         l_color_60 = a_color_48;
         break;
      case 3:
         l_text_124 = "  :";
         l_text_132 = (ai_28 + 1) + "  ";
         l_text_68 = "   ";
         l_text_76 = "    ";
         l_text_84 = ",      ?";
         l_text_92 = "  ";
         l_text_100 = "SL: " + as_32;
         l_text_108 = "TP: " + as_40;
         l_color_60 = a_color_52;
         break;
      case 4:
         l_text_124 = "  :";
         l_text_132 = (ai_28 + 1) + "  ";
         l_text_68 = "   ";
         l_text_76 = "    ";
         l_text_84 = ",      ?";
         l_text_92 = "  ";
         l_text_100 = "SL: " + as_32;
         l_text_108 = "TP: " + as_40;
         l_color_60 = a_color_48;
         break;
      case 5:
         l_text_124 = "  :";
         l_text_132 = (ai_28 + 1) + "  ";
         l_text_68 = "   ";
         l_text_76 = "    Harami";
         l_text_84 = ",      ?";
         l_text_92 = "  ";
         l_text_100 = "SL: " + as_32;
         l_text_108 = "TP: " + as_40;
         l_color_60 = a_color_52;
         break;
      case 6:
         l_text_124 = "  :";
         l_text_132 = (ai_28 + 1) + "  ";
         l_text_68 = "   ";
         l_text_76 = "    Harami";
         l_text_84 = ",      ?";
         l_text_92 = "  ";
         l_text_100 = "SL: " + as_32;
         l_text_108 = "TP: " + as_40;
         l_color_60 = a_color_48;
         break;
      case 7:
         l_text_124 = "  :";
         l_text_132 = (ai_28 + 1) + "  ";
         l_text_68 = "   ";
         l_text_76 = "  -   .";
         l_text_84 = "       .";
         l_text_92 = "  ";
         l_text_100 = "SL: " + as_32;
         l_text_108 = "TP: " + as_40;
         l_color_60 = a_color_52;
         break;
      case 8:
         l_text_124 = "  :";
         l_text_132 = (ai_28 + 1) + "  ";
         l_text_68 = "  -   ";
         l_text_76 = "  -   .";
         l_text_84 = "       .";
         l_text_92 = "  ";
         l_text_100 = "SL: " + as_32;
         l_text_108 = "TP: " + as_40;
         l_color_60 = a_color_48;
         break;
      case 9:
         l_text_124 = "  :";
         l_text_132 = (ai_28 + 1) + "  ";
         l_text_68 = "  ";
         l_text_76 = "  ,      ";
         l_text_84 = "    .";
         l_text_92 = "  ";
         l_text_100 = "SL: " + as_32;
         l_text_108 = "TP: " + as_40;
         l_color_60 = a_color_52;
         break;
      case 10:
         l_text_124 = "  :";
         l_text_132 = (ai_28 + 1) + "  ";
         l_text_68 = "   ";
         l_text_76 = "  ,      ";
         l_text_84 = "    .";
         l_text_92 = "  ";
         l_text_100 = "SL: " + as_32;
         l_text_108 = "TP: " + as_40;
         l_color_60 = a_color_48;
         break;
      default:
         l_text_124 = "  ";
         l_text_132 = "  !!!";
         l_color_64 = Tomato;
      }
      ObjectMakeLabel("ComPatFound", li_156, li_160 + 20, ai_20);
      ObjectSetText("ComPatFound", l_text_124, 10, "Arial Bold", l_color_64);
      ObjectMakeLabel("ComBarFound", li_156, li_160 + 35, ai_20);
      ObjectSetText("ComBarFound", l_text_132, 10, "Arial", a_color_56);
      ObjectMakeLabel("Commentary1", li_156 + 210, li_160 + 20, ai_20);
      ObjectSetText("Commentary1", l_text_68, 10, "Arial Bold", l_color_60);
      ObjectMakeLabel("Commentary2", li_156, li_160 + 60, ai_20);
      ObjectSetText("Commentary2", l_text_76, 10, "Arial", a_color_56);
      ObjectMakeLabel("Commentary3", li_156, li_160 + 75, ai_20);
      ObjectSetText("Commentary3", l_text_84, 10, "Arial", a_color_56);
      ObjectMakeLabel("Commentary4", li_156, li_160 + 95, ai_20);
      ObjectSetText("Commentary4", l_text_92, 10, "Arial Bold", l_color_60);
      ObjectMakeLabel("Commentary5", li_156, li_160 + 115, ai_20);
      ObjectSetText("Commentary5", l_text_100, 10, "Arial Bold", a_color_56);
      ObjectMakeLabel("Commentary6", li_156, li_160 + 130, ai_20);
      ObjectSetText("Commentary6", l_text_108, 10, "Arial Bold", a_color_56);
      li_156 += 420;
      li_160 = 2;
   }
   /*ObjectMakeLabel("CommentaryCopyright", li_156, li_160 + 2, ai_20);
   ObjectSetText("CommentaryCopyright", "Copyright 2008 (c) for all MT4", 10, "Arial Bold", a_color_56);
   ObjectMakeLabel("CommentaryWarning", li_156, li_160 + 17, ai_20);
   ObjectSetText("CommentaryWarning", "     -", 8, "Arial", Red);
   ObjectMakeLabel("CommentaryWarning1", li_156, li_160 + 27, ai_20);
   ObjectSetText("CommentaryWarning1", "      .", 8, "Arial", Red);
   ObjectMakeLabel("CommentaryWarning2", li_156, li_160 + 37, ai_20);
   ObjectSetText("CommentaryWarning2", "       ", 8, "Arial", Red);
   */
   if (DispScan) {
      ObjectMakeLabel("ScanTitle", li_156, li_160 + 55, ai_20);
      ObjectSetText("ScanTitle", " ()", 12, "Arial Bold", TitlesColor);
      ObjectMakeLabel("ScanM1", li_156, li_160 + 80, ai_20);
      ObjectSetText("ScanM1", "M1", 12, "Arial Bold", TitlesColor);
      ObjectMakeLabel("ScanM5", li_156 + 30, li_160 + 80, ai_20);
      ObjectSetText("ScanM5", "M5", 12, "Arial Bold", TitlesColor);
      ObjectMakeLabel("ScanM15", li_156 + 60, li_160 + 80, ai_20);
      ObjectSetText("ScanM15", "M15", 12, "Arial Bold", TitlesColor);
      ObjectMakeLabel("ScanM30", li_156 + 100, li_160 + 80, ai_20);
      ObjectSetText("ScanM30", "M30", 12, "Arial Bold", TitlesColor);
      ObjectMakeLabel("ScanH1", li_156 + 140, li_160 + 80, ai_20);
      ObjectSetText("ScanH1", "H1", 12, "Arial Bold", TitlesColor);
      ObjectMakeLabel("ScanH4", li_156 + 170, li_160 + 80, ai_20);
      ObjectSetText("ScanH4", "H4", 12, "Arial Bold", TitlesColor);
      ObjectMakeLabel("ScanD1", li_156 + 200, li_160 + 80, ai_20);
      ObjectSetText("ScanD1", "D1", 12, "Arial Bold", TitlesColor);
      l_count_140 = 0;
      pattern_type = FindPattern(Symbol(), l_count_140, PERIOD_M1);
      for (string l_text_168 = "0"; pattern_type == 0 && l_count_140 < LookBackForPattern; l_text_168 = l_count_140 + 1) {
         l_count_140++;
         pattern_type = FindPattern(Symbol(), l_count_140, PERIOD_M1);
      }
      switch (pattern_type) {
      case 1:
         l_text_148 = "u";
         g_color_132 = a_color_52;
         break;
      case 2:
         l_text_148 = "u";
         g_color_132 = a_color_48;
         break;
      case 3:
         l_text_148 = "X";
         g_color_132 = a_color_52;
         break;
      case 4:
         l_text_148 = "X";
         g_color_132 = a_color_48;
         break;
      case 5:
         l_text_148 = "";
         g_color_132 = a_color_52;
         break;
      case 6:
         l_text_148 = "";
         g_color_132 = a_color_48;
         break;
      case 7:
         l_text_148 = "S";
         g_color_132 = a_color_52;
         break;
      case 8:
         l_text_148 = "S";
         g_color_132 = a_color_48;
         break;
      case 9:
         l_text_148 = "l";
         g_color_132 = a_color_52;
         break;
      case 10:
         l_text_148 = "l";
         g_color_132 = a_color_48;
         break;
      default:
         l_text_148 = "K";
         g_color_132 = a_color_56;
      }
      ObjectMakeLabel("ScanM1O", li_156, li_160 + 100, ai_20);
      ObjectSetText("ScanM1O", l_text_148, 12, "Wingdings", g_color_132);
      ObjectMakeLabel("ScanM1B", li_156, li_160 + 120, ai_20);
      ObjectSetText("ScanM1B", l_text_168, 12, "Arial", g_color_132);
      
      
      l_count_140 = 0;
      l_text_168 = "0";
      pattern_type = FindPattern(Symbol(), l_count_140, PERIOD_M5);
      while (pattern_type == 0 && l_count_140 < LookBackForPattern) {
         l_count_140++;
         pattern_type = FindPattern(Symbol(), l_count_140, PERIOD_M5);
         l_text_168 = l_count_140 + 1;
      }
      switch (pattern_type) {
      case 1:
         l_text_148 = "u";
         g_color_132 = a_color_52;
         break;
      case 2:
         l_text_148 = "u";
         g_color_132 = a_color_48;
         break;
      case 3:
         l_text_148 = "X";
         g_color_132 = a_color_52;
         break;
      case 4:
         l_text_148 = "X";
         g_color_132 = a_color_48;
         break;
      case 5:
         l_text_148 = "";
         g_color_132 = a_color_52;
         break;
      case 6:
         l_text_148 = "";
         g_color_132 = a_color_48;
         break;
      case 7:
         l_text_148 = "S";
         g_color_132 = a_color_52;
         break;
      case 8:
         l_text_148 = "S";
         g_color_132 = a_color_48;
         break;
      case 9:
         l_text_148 = "l";
         g_color_132 = a_color_52;
         break;
      case 10:
         l_text_148 = "l";
         g_color_132 = a_color_48;
         break;
      default:
         l_text_148 = "K";
         g_color_132 = a_color_56;
      }
      ObjectMakeLabel("ScanM5O", li_156 + 33, li_160 + 100, ai_20);
      ObjectSetText("ScanM5O", l_text_148, 12, "Wingdings", g_color_132);
      ObjectMakeLabel("ScanM5B", li_156 + 32, li_160 + 120, ai_20);
      ObjectSetText("ScanM5B", l_text_168, 12, "Arial", g_color_132);
      l_count_140 = 0;
      pattern_type = FindPattern(Symbol(), l_count_140, PERIOD_M15);
      for (l_text_168 = "0"; pattern_type == 0 && l_count_140 < LookBackForPattern; l_text_168 = l_count_140 + 1) {
         l_count_140++;
         pattern_type = FindPattern(Symbol(), l_count_140, PERIOD_M15);
      }
      switch (pattern_type) {
      case 1:
         l_text_148 = "u";
         g_color_132 = a_color_52;
         break;
      case 2:
         l_text_148 = "u";
         g_color_132 = a_color_48;
         break;
      case 3:
         l_text_148 = "X";
         g_color_132 = a_color_52;
         break;
      case 4:
         l_text_148 = "X";
         g_color_132 = a_color_48;
         break;
      case 5:
         l_text_148 = "";
         g_color_132 = a_color_52;
         break;
      case 6:
         l_text_148 = "";
         g_color_132 = a_color_48;
         break;
      case 7:
         l_text_148 = "S";
         g_color_132 = a_color_52;
         break;
      case 8:
         l_text_148 = "S";
         g_color_132 = a_color_48;
         break;
      case 9:
         l_text_148 = "l";
         g_color_132 = a_color_52;
         break;
      case 10:
         l_text_148 = "l";
         g_color_132 = a_color_48;
         break;
      default:
         l_text_148 = "K";
         g_color_132 = a_color_56;
      }
      ObjectMakeLabel("ScanM15O", li_156 + 65, li_160 + 100, ai_20);
      ObjectSetText("ScanM15O", l_text_148, 12, "Wingdings", g_color_132);
      ObjectMakeLabel("ScanM15B", li_156 + 64, li_160 + 120, ai_20);
      ObjectSetText("ScanM15B", l_text_168, 12, "Arial", g_color_132);
      l_count_140 = 0;
      pattern_type = FindPattern(Symbol(), l_count_140, PERIOD_M30);
      for (l_text_168 = "0"; pattern_type == 0 && l_count_140 < LookBackForPattern; l_text_168 = l_count_140 + 1) {
         l_count_140++;
         pattern_type = FindPattern(Symbol(), l_count_140, PERIOD_M30);
      }
      switch (pattern_type) {
      case 1:
         l_text_148 = "u";
         g_color_132 = a_color_52;
         break;
      case 2:
         l_text_148 = "u";
         g_color_132 = a_color_48;
         break;
      case 3:
         l_text_148 = "X";
         g_color_132 = a_color_52;
         break;
      case 4:
         l_text_148 = "X";
         g_color_132 = a_color_48;
         break;
      case 5:
         l_text_148 = "";
         g_color_132 = a_color_52;
         break;
      case 6:
         l_text_148 = "";
         g_color_132 = a_color_48;
         break;
      case 7:
         l_text_148 = "S";
         g_color_132 = a_color_52;
         break;
      case 8:
         l_text_148 = "S";
         g_color_132 = a_color_48;
         break;
      case 9:
         l_text_148 = "l";
         g_color_132 = a_color_52;
         break;
      case 10:
         l_text_148 = "l";
         g_color_132 = a_color_48;
         break;
      default:
         l_text_148 = "K";
         g_color_132 = a_color_56;
      }
      ObjectMakeLabel("ScanM30O", li_156 + 110, li_160 + 100, ai_20);
      ObjectSetText("ScanM30O", l_text_148, 12, "Wingdings", g_color_132);
      ObjectMakeLabel("ScanM30B", li_156 + 110, li_160 + 120, ai_20);
      ObjectSetText("ScanM30B", l_text_168, 12, "Arial", g_color_132);
      l_count_140 = 0;
      pattern_type = FindPattern(Symbol(), l_count_140, PERIOD_H1);
      for (l_text_168 = "0"; pattern_type == 0 && l_count_140 < LookBackForPattern; l_text_168 = l_count_140 + 1) {
         l_count_140++;
         pattern_type = FindPattern(Symbol(), l_count_140, PERIOD_H1);
      }
      switch (pattern_type) {
      case 1:
         l_text_148 = "u";
         g_color_132 = a_color_52;
         break;
      case 2:
         l_text_148 = "u";
         g_color_132 = a_color_48;
         break;
      case 3:
         l_text_148 = "X";
         g_color_132 = a_color_52;
         break;
      case 4:
         l_text_148 = "X";
         g_color_132 = a_color_48;
         break;
      case 5:
         l_text_148 = "";
         g_color_132 = a_color_52;
         break;
      case 6:
         l_text_148 = "";
         g_color_132 = a_color_48;
         break;
      case 7:
         l_text_148 = "S";
         g_color_132 = a_color_52;
         break;
      case 8:
         l_text_148 = "S";
         g_color_132 = a_color_48;
         break;
      case 9:
         l_text_148 = "l";
         g_color_132 = a_color_52;
         break;
      case 10:
         l_text_148 = "l";
         g_color_132 = a_color_48;
         break;
      default:
         l_text_148 = "K";
         g_color_132 = a_color_56;
      }
      ObjectMakeLabel("ScanH1O", li_156 + 145, li_160 + 100, ai_20);
      ObjectSetText("ScanH1O", l_text_148, 12, "Wingdings", g_color_132);
      ObjectMakeLabel("ScanH1B", li_156 + 146, li_160 + 120, ai_20);
      ObjectSetText("ScanH1B", l_text_168, 12, "Arial", g_color_132);
      l_count_140 = 0;
      pattern_type = FindPattern(Symbol(), l_count_140, PERIOD_H4);
      for (l_text_168 = "0"; pattern_type == 0 && l_count_140 < LookBackForPattern; l_text_168 = l_count_140 + 1) {
         l_count_140++;
         pattern_type = FindPattern(Symbol(), l_count_140, PERIOD_H4);
      }
      switch (pattern_type) {
      case 1:
         l_text_148 = "u";
         g_color_132 = a_color_52;
         break;
      case 2:
         l_text_148 = "u";
         g_color_132 = a_color_48;
         break;
      case 3:
         l_text_148 = "X";
         g_color_132 = a_color_52;
         break;
      case 4:
         l_text_148 = "X";
         g_color_132 = a_color_48;
         break;
      case 5:
         l_text_148 = "";
         g_color_132 = a_color_52;
         break;
      case 6:
         l_text_148 = "";
         g_color_132 = a_color_48;
         break;
      case 7:
         l_text_148 = "S";
         g_color_132 = a_color_52;
         break;
      case 8:
         l_text_148 = "S";
         g_color_132 = a_color_48;
         break;
      case 9:
         l_text_148 = "l";
         g_color_132 = a_color_52;
         break;
      case 10:
         l_text_148 = "l";
         g_color_132 = a_color_48;
         break;
      default:
         l_text_148 = "K";
         g_color_132 = a_color_56;
      }
      ObjectMakeLabel("ScanH4O", li_156 + 172, li_160 + 100, ai_20);
      ObjectSetText("ScanH4O", l_text_148, 12, "Wingdings", g_color_132);
      ObjectMakeLabel("ScanH4B", li_156 + 174, li_160 + 120, ai_20);
      ObjectSetText("ScanH4B", l_text_168, 12, "Arial", g_color_132);
      NewPat = StrToInteger(l_text_168);
      TimeNewPat = iTime(Symbol(),PERIOD_H4,0);
      TimeOldPat = GlobalVariableGet(Symbol()+"_OP_TimeOldPatternBarH4");
      OldPat = GlobalVariableGet(Symbol()+"_OP_OldPatternBarH4");
      if ((NewPat<=OldPat || OldPat==0) 
         && (TimeNewPat-TimeOldPat>=1440) 
         && Alert_H4==true )
         {
         Alert(Symbol(),"     4");
         TimeOldPat = TimeNewPat;
         GlobalVariableSet(Symbol()+"_OP_TimeOldPatternBarH4",TimeOldPat);
         OldPat = NewPat;
         GlobalVariableSet(Symbol()+"_OP_OldPatternBarH4",OldPat);
         }


      l_count_140 = 0;
      pattern_type = FindPattern(Symbol(), l_count_140, PERIOD_D1);
      for (l_text_168 = "0"; pattern_type == 0 && l_count_140 < LookBackForPattern; l_text_168 = l_count_140 + 1) {
         l_count_140++;
         pattern_type = FindPattern(Symbol(), l_count_140, PERIOD_D1);
      }
      switch (pattern_type) {
      case 1:
         l_text_148 = "u";
         g_color_132 = a_color_52;
         break;
      case 2:
         l_text_148 = "u";
         g_color_132 = a_color_48;
         break;
      case 3:
         l_text_148 = "X";
         g_color_132 = a_color_52;
         break;
      case 4:
         l_text_148 = "X";
         g_color_132 = a_color_48;
         break;
      case 5:
         l_text_148 = "";
         g_color_132 = a_color_52;
         break;
      case 6:
         l_text_148 = "";
         g_color_132 = a_color_48;
         break;
      case 7:
         l_text_148 = "S";
         g_color_132 = a_color_52;
         break;
      case 8:
         l_text_148 = "S";
         g_color_132 = a_color_48;
         break;
      case 9:
         l_text_148 = "l";
         g_color_132 = a_color_52;
         break;
      case 10:
         l_text_148 = "l";
         g_color_132 = a_color_48;
         break;
      default:
         l_text_148 = "K";
         g_color_132 = a_color_56;
      }
      ObjectMakeLabel("ScanD1O", li_156 + 203, li_160 + 100, ai_20);
      ObjectSetText("ScanD1O", l_text_148, 12, "Wingdings", g_color_132);
      ObjectMakeLabel("ScanD1B", li_156 + 200, li_160 + 120, ai_20);
      ObjectSetText("ScanD1B", l_text_168, 12, "Arial", g_color_132);
   }
}

int CheckPrecision() {
   if (StringFind(Symbol(), "JPY", 0) != -1) return (2);
   return (4);
}

int ObjectMakeLabel(string a_name_0, int a_x_8, int a_y_12, int a_window_16) {
   ObjectCreate(a_name_0, OBJ_LABEL, a_window_16, 0, 0);
   ObjectSet(a_name_0, OBJPROP_CORNER, 0);
   ObjectSet(a_name_0, OBJPROP_XDISTANCE, a_x_8);
   ObjectSet(a_name_0, OBJPROP_YDISTANCE, a_y_12);
   ObjectSet(a_name_0, OBJPROP_BACK, TRUE);
   return (0);
}

void CleanUp() {
   ObjectDelete("LegendColorUp");
   ObjectDelete("LegendColorDn");
   ObjectDelete("LegendColorSU");
   ObjectDelete("LegendColorSN");
   ObjectDelete("ENGULFING");
   ObjectDelete("ENGULFINGS");
   ObjectDelete("SOLDIER");
   ObjectDelete("SOLDIERS");
   ObjectDelete("OUTSIDE");
   ObjectDelete("OUTSIDES");
   ObjectDelete("INSIDE");
   ObjectDelete("INSIDES");
   ObjectDelete("CLOUD");
   ObjectDelete("CLOUDS");
   ObjectDelete("PROFITTARGET");
   ObjectDelete("STOPTARGET");
   ObjectDelete("CommentaryTitle");
   ObjectDelete("CommentaryCopyRight");
   ObjectDelete("CommentaryWarning");
   ObjectDelete("CommentaryWarning1");
   ObjectDelete("CommentaryWarning2");
   ObjectDelete("ComPatFound");
   ObjectDelete("ComBarFound");
   ObjectDelete("Commentary1");
   ObjectDelete("Commentary2");
   ObjectDelete("Commentary3");
   ObjectDelete("Commentary4");
   ObjectDelete("Commentary5");
   ObjectDelete("Commentary6");
   ObjectDelete("ScanTitle");
   ObjectDelete("ScanM1");
   ObjectDelete("ScanM5");
   ObjectDelete("ScanM15");
   ObjectDelete("ScanM30");
   ObjectDelete("ScanH1");
   ObjectDelete("ScanH4");
   ObjectDelete("ScanD1");
   ObjectDelete("ScanM1O");
   ObjectDelete("ScanM5O");
   ObjectDelete("ScanM15O");
   ObjectDelete("ScanM30O");
   ObjectDelete("ScanH1O");
   ObjectDelete("ScanH4O");
   ObjectDelete("ScanD1O");
   ObjectDelete("ScanM1B");
   ObjectDelete("ScanM5B");
   ObjectDelete("ScanM15B");
   ObjectDelete("ScanM30B");
   ObjectDelete("ScanH1B");
   ObjectDelete("ScanH4B");
   ObjectDelete("ScanD1B");
   int li_0 = 1;
   for (string l_name_4 = "IBFXCPRPATTERN" + li_0; ObjectFind(l_name_4) == 0; l_name_4 = "IBFXCPRPATTERN" + li_0) {
      ObjectDelete(l_name_4);
      li_0++;
   }
}